/*
Loads a binary file into Zx3 memory.
(C) 2010 Jeroen Domburg (jeroen AT spritesmods.com)

This program is free software: you can redistribute it and/or modify
t under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
	    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
			    
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
.global _start

//Entry points of c functions
#define FOPEN 0xC013C5E4
#define FREAD 0xC013C94C

_start:
	stmfd sp!,{r3-r9,lr}
	//Open file descriptor
	ldr r0,=fileName
	ldr r1,=readOnly
	ldr r6,=FOPEN
	blx r6
	movs r5,r0 //save fd
	beq exit //exit if file cant be found or whatever

	//Copy file to memory
	ldr r4,=0xC6500100
loop:
	mov r0,r4 //buff
	mov r1,#1 //size
	mov r2,#512 //nmemb
	mov r3,r5 //fd
	ldr r6,=FREAD
	blx r6
	add r4,r4,#512
	cmp r0,#0
	bgt loop

	//Overwrite jump table entry for info icon press with jump to our routine
	ldr r0,=0xC0286188
	ldr r1,=infoPressRoutine
	str r1,[r0],#4

	//All done. Return to ash.
	//No fclose because I'm a lazy ass who can't be bothered to find that function.
exit:
	ldmfd sp!, {r3-r9,pc}


//This gets called instead of the firmware button press routine.
infoPressRoutine:
	//Call Our(tm) firmware stuff thingy
	ldr r1,=0xC6500100
	blx r1
	//All done, return as if nothing happened.
	ldr pc,=0xC028636C

//alternative return
//	ldr r0,[sp]
//	ldmfd sp!,{r3-r11,pc}

//Keep constants here, underneath the code! (alignment)
fileName:
.string "d:\\HACKAPP.BIN"
readOnly:
.string "r"
